

#    MIDAS Access Client  for the  DataAcquisitionControl service

global env
source [file join $env(MIDASBASE) SOAP tcl MIDASAccessClient.tcl]    ;#   load default support procedures

global DataAcquisitionControlServerHost DataAcquisitionControlServerPort
global SOAPServerHost SOAPServerPort

if {[info exists DataAcquisitionControlServerHost] == 0} then {set DataAcquisitionControlServerHost $SOAPServerHost}
if {[info exists DataAcquisitionControlServerPort] == 0} then {set DataAcquisitionControlServerPort $SOAPServerPort}

variable uri "urn:DataAcquisitionControlServer"
variable proxy "http://$DataAcquisitionControlServerHost:$DataAcquisitionControlServerPort/DataAcquisitionControlServer"

set DataAcquisitionControlClient__TimeOut 10000


SOAP::create DataAcquisitionControlClient__Get-State -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name Get-State \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request 

SOAP::create DataAcquisitionControlClient__Get-LastError -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name Get-LastError \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request 

SOAP::create DataAcquisitionControlClient__Get-Information -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name Get-Information \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request

SOAP::create DataAcquisitionControlClient__Do-Reset -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name Do-Reset \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create DataAcquisitionControlClient__Do-SetUp -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name Do-SetUp \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create DataAcquisitionControlClient__Do-Stop -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name Do-Stop \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create DataAcquisitionControlClient__Do-Go -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name Do-Go \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create DataAcquisitionControlClient__Get-Counters -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name Get-Counters \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request 

SOAP::create DataAcquisitionControlClient__Get-Rates -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name Get-Rates \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request

SOAP::create DataAcquisitionControlClient__ServerVerbose -proxy $proxy -uri $uri -timeout 1000 \
     -name ServerVerbose \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create DataAcquisitionControlClient__ServerImplementation -proxy $proxy -uri $uri -timeout 1000 \
     -name ServerImplementation \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 




package provide DataAcquisitionControlClient 1.0
