
#    MIDAS Access Server  for  MEIS MPX system

global env
source [file join $env(MIDASBASE) TclHttpd tcl MIDASDomainHandler.tcl]       ;#  load default support procedures

source [file join $env(MIDASBASE) MIDASpackages MPXAccess1.0 pkgIndex.tcl]
package require MPXAccess

global MIDAS_MPXAccessServer_Verbose
set MIDAS_MPXAccessServer_Verbose 0

# Use namespaces to isolate our methods
namespace eval urn:MPXAccessServer {

    proc AccessServerVerbose {option} {
        do_AccessServerVerbose $option
        return [rpcvar::rpcvar int 0]
    }

    proc Reset {} {
        do_Reset
        return [rpcvar::rpcvar int 0]
    }

    proc Test {} {
        do_Test
        return [rpcvar::rpcvar int 0]
    }

    proc Set {Crate Address Flen Fposn Value} {
        do_Set $Crate $Address $Flen $Fposn $Value
        return [rpcvar::rpcvar int 0]
    }

    proc Get {Crate Address Flen Fposn} {
        set vl [do_Get $Crate $Address  $Flen $Fposn]
        return [rpcvar::rpcvar int $vl]
    }

    proc Open {Crate Address Channel} {
        set vl [do_Open $Crate $Address  $Channel]
        return [rpcvar::rpcvar int $vl]
    }

    proc Read {Crate Address Length} {
        set vl [do_Read $Crate $Address $Length]
        return [rpcvar::rpcvar string $vl]
    }

    proc do_AccessServerVerbose {option} {
        global MIDAS_MPXAccessServer_Verbose
        if {$MIDAS_MPXAccessServer_Verbose} {puts "called method AccessServerVerbose with parameter $option"}
        set MIDAS_MPXAccessServer_Verbose $option
        MPXAccess_Verbose $option
    }

    proc do_Reset {} {
       set z [catch {MPXAccess_Reset} m]
       if {$z == 0} then {
          return 0
       } else {
           return -code error -errorcode 0x10005 -errorinfo "received error response: rc=$z\n  $m"
       }
    }

    proc do_Test {} {
       set z [catch {MPXAccess_Test} m]
       if {$z == 0} then {
          return 0
       } else {
           return -code error -errorcode 0x10005 -errorinfo "received error response: rc=$z\n  $m"
       }
    }

    proc do_Set {Crate Address Flen Fposn Value} {
       set z [catch {MPXAccess_Set -c $Crate -a $Address -l $Flen -p $Fposn -d $Value} m]
       if {$z == 0} then {
          return 0
       } else {
           return -code error -errorcode 0x10005 -errorinfo "received error response: rc=$z\n  $m"
       }
    }

    proc do_Get {Crate Address Flen Fposn} {
       set z [catch {MPXAccess_Get -c $Crate -l $Flen -p $Fposn -a $Address} m]
       if {$z == 0} then {
          return $m
       } else {
           return -code error -errorcode 0x10005 -errorinfo "received error response: rc=$z\n  $m"
       }
    }

    proc do_Open {Crate Address Channel} {
       set z [catch {MPXAccess_Open -c $Crate -a $Address -p $Channel} m]
       if {$z == 0} then {
          return $m
       } else {
           return -code error -errorcode 0x10005 -errorinfo "received error response: rc=$z\n  $m"
       }
    }

    proc do_Read {Crate Address Length} {
       set z [catch {MPXAccess_Read -c $Crate -a $Address -l $Length} m]
       if {$z == 0} then {
          return $m
       } else {
           return -code error -errorcode 0x10005 -errorinfo "received error response: rc=$z\n  $m"
       }
    }


    # We have to publish the public methods...

     SOAP::export AccessServerVerbose
     SOAP::export Reset
     SOAP::export Test
     SOAP::export Set
     SOAP::export Get
     SOAP::export Read
     SOAP::export Open
}

# register this service with tclhttpd
puts [SOAP::Domain::register  -prefix  /MPXAccessServer -namespace urn:MPXAccessServer -uri urn:MPXAccessServer]


proc ::SOAP::Domain::MIDAS_SOAPDomainHandler_/MPXAccessServer {optsname sock args} {   \
    ::SOAP::Domain::MIDAS_SOAPDomainHandler_/DefaultAccessServer $optsname $sock $args}
